/*
  Copyright 2012-2013 by
  Centre de recherche INRIA Sophia-Antipolis Mediterranee, equipe APICS,
  Sophia Antipolis, France.

  Contributors S. Chevillard
  sylvain.chevillard@ens-lyon.org

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation, either version 3 of the
  License, or (at your option) any later version.

  It is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this file.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef __BROWN_H
#define __BROWN_H 1

#include <mpfr.h>
#include <limits.h>

/* Some macros inspired from mpfr-impl.h */
#define MPFR_PREC(x)      ((x)->_mpfr_prec)
#define MPFR_EXP(x)       ((x)->_mpfr_exp)
#define MPFR_SIGN(x)      ((x)->_mpfr_sign)
#define MPFR_GET_EXP(x)   MPFR_EXP (x)
#define MPFR_CHANGE_SIGN(x) (MPFR_SIGN(x) = -MPFR_SIGN(x))
#define MPFR_IS_ZERO(x)  (mpfr_zero_p(x))
int __gmpfr_int_ceil_log2 (unsigned long n); /* Provided by MPFR in int_ceil_log2.c */
#define MPFR_INT_CEIL_LOG2(x) (__gmpfr_int_ceil_log2(x))
#define MPFR_SMALL_PRECISION 32

#ifndef MAX
#define MAX(a,b) (((a)>(b))?(a):(b))
#endif

void mpfr_mul_ui2 (mpfr_ptr y, mpfr_srcptr x,
                   unsigned long int v1, unsigned long int v2, mpfr_rnd_t mode);

void mpfr_mul_ui5 (mpfr_ptr y, mpfr_srcptr x,
                   unsigned long int v1, unsigned long int v2,
                   unsigned long int v3, unsigned long int v4,
                   unsigned long int v5, mpfr_rnd_t mode);

void mpfr_div_ui2 (mpfr_ptr y, mpfr_srcptr x,
                   unsigned long int v1, unsigned long int v2, mpfr_rnd_t mode);

void mpfr_div_ui8 (mpfr_ptr y, mpfr_srcptr x,
                   unsigned long int v1, unsigned long int v2,
                   unsigned long int v3, unsigned long int v4,
                   unsigned long int v5, unsigned long int v6,
                   unsigned long int v7, unsigned long int v8, mpfr_rnd_t mode);

void mpfr_div_si3 (mpfr_ptr y, mpfr_srcptr x,
                   long int v1, long int v2,
                   long int v3, mpfr_rnd_t mode);

void mpfr_Browns_const (mpfr_ptr s, mpfr_prec_t prec);

#endif
